; #########################################################################
; Author: William F Cravener - 07/28/08
; #########################################################################

.486
.model flat,stdcall
option casemap:none

; #########################################################################

        include \masm32\include\windows.inc
        include \masm32\include\masm32.inc
        include \masm32\include\user32.inc
        include \masm32\include\kernel32.inc
        include \masm32\include\gdi32.inc
        include \masm32\include\oleaut32.inc

        includelib \masm32\lib\masm32.lib
        includelib \masm32\lib\user32.lib
        includelib \masm32\lib\kernel32.lib
        includelib \masm32\lib\gdi32.lib
        includelib \masm32\lib\oleaut32.lib

; #########################################################################

        WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
        WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
        ListBox PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
        ListBoxProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
        Get_Listbox_Items PROTO :DWORD,:DWORD
        Parse_Items_To_Listbox PROTO :DWORD,:DWORD
        TopXY PROTO :DWORD,:DWORD

.data
        hInstance     dd 0
        hIcon         dd 0
        hWnd          dd 0
        hBitmap       dd 0
        hListbox      dd 0
        prevProc      dd 0

        className     db "PasteIt_Class",0
        appName       db "PasteIt",0
        lstBox        db "LISTBOX",0
        fileName      db "Items.txt",0
        itemBuffer    db 256 dup (0)

.code
start:
        invoke FindWindow,ADDR className,0
        cmp eax,0
        je @F
        mov eax,0
        ret
        @@:

        invoke GetModuleHandle,0
        mov hInstance,eax

        invoke LoadImage,hInstance,500,IMAGE_ICON,32,32,LR_DEFAULTCOLOR
        mov hIcon,eax

        invoke WinMain,hInstance,0,0,SW_SHOWDEFAULT
        invoke ExitProcess,eax

; ########################################################################

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
        LOCAL Wwd:DWORD
        LOCAL Wht:DWORD
        LOCAL Wtx:DWORD
        LOCAL Wty:DWORD

	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,0
	mov   wc.cbWndExtra,0
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,0
	mov   wc.lpszMenuName,0
	mov   wc.lpszClassName,OFFSET className
	push  hIcon
	pop   wc.hIcon
	push  hIcon
	pop   wc.hIconSm
	invoke LoadCursor,0,IDC_ARROW
	mov   wc.hCursor,eax

	invoke RegisterClassEx,ADDR wc

        mov Wwd,600
        mov Wht,300

        invoke GetSystemMetrics,SM_CXSCREEN
        invoke TopXY,Wwd,eax
        mov Wtx,eax

        invoke GetSystemMetrics,SM_CYSCREEN
        invoke TopXY,Wht,eax
        sub eax,100
        mov Wty,eax

	invoke CreateWindowEx,WS_EX_TOPMOST,ADDR className,ADDR appName,\
               WS_POPUP,\
               Wtx,Wty,Wwd,Wht,\
               0,0,
               hInst,0
	mov    hWnd,eax

	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd

        StartLoop:
               invoke GetMessage,ADDR msg,0,0,0
               cmp eax,0
               je ExitLoop
               invoke TranslateMessage,ADDR msg
               invoke DispatchMessage,ADDR msg
               jmp StartLoop
        ExitLoop:

	mov eax,msg.wParam
	ret

WinMain endp

; ########################################################################

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL ps:PAINTSTRUCT
    LOCAL rect:RECT
    LOCAL hdc:HDC
    LOCAL hMemDC:HDC

    .if uMsg==WM_CREATE

        invoke LoadBitmap,hInstance,600
        mov hBitmap,eax

        ;------------------------------------------
        ; Round the corners of our window space
        ;------------------------------------------
        invoke CreateRoundRectRgn,0,0,600,300,30,30
        invoke SetWindowRgn,hWin,eax,TRUE
        ;------------------------------------------

        invoke BmpButton,hWin,530,18,800,900,1000

        invoke ListBox,51,55,500,195,hWin,700
        mov hListbox,eax

        invoke SetWindowLong,hListbox,GWL_WNDPROC,ListBoxProc
        mov prevProc,eax

        invoke Get_Listbox_Items,ADDR fileName,hWin

        invoke SetFocus,hListbox
 
        invoke SendMessage,hListbox,LB_SETCURSEL,0,0

    .elseif uMsg==WM_COMMAND

        .if wParam==1000

            invoke SendMessage,hWin,WM_DESTROY,0,0

        .endif

    .elseif uMsg==WM_PAINT

	invoke BeginPaint,hWin,addr ps
	mov hdc,eax

       	invoke CreateCompatibleDC,hdc
	mov hMemDC,eax

	invoke SelectObject,hMemDC,hBitmap

    	invoke GetClientRect,hWin,addr rect

	invoke BitBlt,hdc,0,0,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY

	invoke DeleteDC,hMemDC

	invoke EndPaint,hWin,addr ps

    .elseif uMsg==WM_LBUTTONDOWN

        invoke SendMessage,hWin,WM_NCLBUTTONDOWN,HTCAPTION,0

    .elseif uMsg==WM_DESTROY

        invoke DeleteObject,hBitmap

        invoke PostQuitMessage,0

    .else

        invoke DefWindowProc,hWin,uMsg,wParam,lParam
        ret

    .endif

     xor eax,eax
     ret

WndProc endp

; ########################################################################

ListBox proc a:DWORD,b:DWORD,wd:DWORD,ht:DWORD,hParent:DWORD,ID:DWORD

    invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR lstBox,0,
           WS_VSCROLL or WS_VISIBLE or WS_CHILDWINDOW or \
           LBS_HASSTRINGS or LBS_NOINTEGRALHEIGHT or \
           LBS_DISABLENOSCROLL or LBS_SORT, \
           a,b,wd,ht,hParent,ID,hInstance,0

    ret

ListBox endp

; #########################################################################

ListBoxProc proc hCtl:DWORD,uMsg:DWORD,wParam:DWORD,lParam :DWORD

    LOCAL IndexItem:DWORD
    LOCAL hMem:DWORD
    LOCAL pMem:DWORD
    LOCAL nLen:DWORD
    LOCAL buffer[256]:BYTE

    .if uMsg==WM_LBUTTONDBLCLK

        invoke SendMessage,hCtl,LB_GETCURSEL,0,0
        mov IndexItem,eax

        invoke SendMessage,hCtl,LB_GETTEXT,IndexItem,ADDR buffer

        invoke lstrlen,ADDR buffer
        inc eax 
        mov nLen,eax

        invoke OpenClipboard,0

        invoke GlobalAlloc,GHND,nLen
        mov hMem,eax

        invoke GlobalLock,hMem 
        mov pMem,eax

        lea esi,buffer
        mov edi,pMem 
        mov ecx,nLen
        rep movsb

        invoke EmptyClipboard

        invoke GlobalUnlock,hMem 

        invoke SetClipboardData,CF_TEXT,hMem

        invoke CloseClipboard

        invoke SendMessage,hWnd,WM_DESTROY,0,0

;-----------------------------------------------
; If you remove the SendMessage API above you
; should un-comment the GlobalFree invoke below.
;-----------------------------------------------
;        invoke GlobalFree,hMem
;-----------------------------------------------

    .endif

    invoke CallWindowProc,prevProc,hCtl,uMsg,wParam,lParam
    ret

ListBoxProc endp

; #########################################################################

Get_Listbox_Items proc lpDiskFile:DWORD,hWin:DWORD

    LOCAL hFile:DWORD
    LOCAL hMem:DWORD
    LOCAL ln:DWORD
    LOCAL br:DWORD

    invoke CreateFile,lpDiskFile,GENERIC_READ,FILE_SHARE_READ,
                      0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0

    mov hFile,eax

    invoke GetFileSize,hFile,0
    mov ln,eax

    invoke SysAllocStringByteLen,0,ln
    mov hMem,eax

    invoke ReadFile,hFile,hMem,ln,ADDR br,0

    .if eax != 0

        invoke Parse_Items_To_Listbox,hMem,br

    .endif

    invoke SysFreeString,hMem

    invoke CloseHandle,hFile

    ret

Get_Listbox_Items endp

; #########################################################################

Parse_Items_To_Listbox proc theItems:DWORD, bytesRead:DWORD

    push esi
    push edi

        mov esi,theItems

        mov edi,OFFSET itemBuffer
        
        cmp byte ptr [esi],0
        je gotData 

    getlink:

        dec bytesRead
        jz gotData

        lodsb

        cmp al,0Dh
        je gotlink
 
        stosb

        jmp getlink 

    gotlink:

        mov al,0

        stosb

        push esi

        invoke SendMessage,hListbox,LB_ADDSTRING,0,ADDR itemBuffer

        pop esi

        inc si

        mov edi,OFFSET itemBuffer

        jmp getlink

    gotData:

    pop edi
    pop esi

    ret

Parse_Items_To_Listbox endp

; #########################################################################

TopXY proc wDim:DWORD,sDim:DWORD

    shr sDim,1
    shr wDim,1
    mov eax,wDim
    sub sDim,eax
    mov eax,sDim

    ret

TopXY endp

; ########################################################################

end start

